gtkmm 4.7.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::StringList Class Reference

A list model for strings. More...

`#include <gtkmm/stringlist.h>`

Inheritance diagram for Gtk::StringList:
[legend]

## Public Member Functions
| StringList (StringList && src) noexcept
StringList & | operator= (StringList && src) noexcept
| ~StringList () noexcept override
GtkStringList * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkStringList * | gobj () const
| Provides access to the underlying C GObject. More...
GtkStringList * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | append (const Glib::ustring &string)
| Appends string to self. More...
void | remove (guint position)
| Removes the string at position from self. More...
void | splice (guint position, guint n_removals, const std::vector< Glib::ustring > & additions)
| Changes self by removing n_removals strings and adding additions to it. More...
Glib::ustring | get_string (guint position) const
| Gets the string that is at position in self. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const
Public Member Functions inherited from Gio::ListModel
| ListModel (ListModel &&src) noexcept
ListModel & | operator= (ListModel &&src) noexcept
| ~ListModel () noexcept override
GListModel * | gobj ()
const GListModel * | gobj () const
GType | get_item_type () const
guint | get_n_items () const
Glib::RefPtr< Glib::ObjectBase > | get_object (guint position)
Glib::RefPtr< const Glib::ObjectBase > | get_object (guint position) const
Glib::SignalProxy< void(guint, guint, guint)> | signal_items_changed ()
Glib::RefPtr< Gio::ListModel > | wrap (GListModel *object, bool take_copy=false)
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object. More...

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< StringList > | create (const std::vector< Glib::ustring > & strings)
Static Public Member Functions inherited from Gio::ListModel
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| StringList (const std::vector< Glib::ustring > & strings)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gio::ListModel
| ListModel ()
void | items_changed (guint position, guint removed, guint added)
virtual GType | get_item_type_vfunc ()
virtual guint | get_n_items_vfunc ()
virtual gpointer | get_item_vfunc (guint position)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::StringList > | wrap (GtkStringList * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A list model for strings.

Gtk::StringList is a list model that wraps an array of strings.

The objects in the model have a "string" property.

GtkStringList is well-suited for any place where you would typically use a vector or array of Glib::ustring, but need a list model.

Gtk::StringList as Gtk::Buildable
  The Gtk::StringList implementation of the Gtk::Buildable interface supports adding items directly using the <items> element and specifying elements for each item. Each element supports the regular translation attributes “translatable”, “context” and “comments”.

  Here is a UI definition fragment specifying a Gtk::StringList
  <object class="GtkStringList">
  <items>
  <item translatable="yes">Factory</item>
  <item translatable="yes">Home</item>
  <item translatable="yes">Subway</item>
  </items>
  </object>

See also
  Gio::ListModel

Since gtkmm 3.98:

## Constructor & Destructor Documentation

## ◆ StringList() [1/2]

Gtk::StringList::StringList | ( | StringList && | src | ) |
| noexcept

## ◆ ~StringList()

Gtk::StringList::~StringList | ( |  | ) |
| override noexcept

## ◆ StringList() [2/2]

Gtk::StringList::StringList | ( | const std::vector< Glib::ustring > & | strings | ) |
| protected

## Member Function Documentation

## ◆ append()

void Gtk::StringList::append | ( | const Glib::ustring & | string | ) |

Appends string to self.

The string will be copied. See take() for a way to avoid that.

Parameters

  string | The string to insert.

## ◆ create()

static Glib::RefPtr<StringList> Gtk::StringList::create | ( | const std::vector< Glib::ustring > & | strings | ) |
| static

## ◆ get_string()

Glib::ustring Gtk::StringList::get_string | ( | guint | position | ) | const

Gets the string that is at position in self.

If self does not contain position items, `nullptr` is returned.

This function returns the const char *. To get the object wrapping it, use Glib::list_model_get_item().

Parameters

  position | The position to get the string for.

Returns
  The string at the given position.

## ◆ get_type()

static GType Gtk::StringList::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkStringList* Gtk::StringList::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkStringList* Gtk::StringList::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkStringList* Gtk::StringList::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

StringList& Gtk::StringList::operator= | ( | StringList && | src | ) |
| noexcept

## ◆ remove()

void Gtk::StringList::remove | ( | guint | position | ) |

Removes the string at position from self.

position must be smaller than the current length of the list.

Parameters

  position | The position of the string that is to be removed.

## ◆ splice()

void Gtk::StringList::splice | ( | guint | position,
|  | guint | n_removals,
|  | const std::vector< Glib::ustring > & | additions
| ) |  |

Changes self by removing n_removals strings and adding additions to it.

This function is more efficient than append() and remove(), because it only emits the signal_items_changed() signal once for the change.

This function copies the strings in additions.

The parameters position and n_removals must be correct (ie: position + n_removals must be less than or equal to the length of the list at the time this function is called).

Parameters

  position | The position at which to make the change.
  n_removals | The number of strings to remove.
  additions | The strings to add.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::StringList > wrap | ( | GtkStringList * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.